/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.commons.CallRouteConfig;
import com.flamesgroup.commons.SmsRouteConfig;
import com.flamesgroup.storage.convert.CallRouteConfigBinding;
import com.flamesgroup.storage.convert.InetAddressBinding;
import com.flamesgroup.storage.convert.SmsRouteConfigBinding;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.ServerRecord;

import java.net.InetAddress;
import java.util.Arrays;
import java.util.List;

import org.jooq.Field;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Server extends TableImpl<ServerRecord> {

	private static final long serialVersionUID = -1484579313;

	/**
	 * The reference instance of <code>public.server</code>
	 */
	public static final Server SERVER = new Server();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<ServerRecord> getRecordType() {
		return ServerRecord.class;
	}

	/**
	 * The column <code>public.server.id</code>.
	 */
	public final TableField<ServerRecord, Long> ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.server.name</code>.
	 */
	public final TableField<ServerRecord, String> NAME = createField("name", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.server.vs_enable</code>.
	 */
	public final TableField<ServerRecord, Boolean> VS_ENABLE = createField("vs_enable", org.jooq.impl.SQLDataType.BOOLEAN.defaulted(true), this, "");

	/**
	 * The column <code>public.server.ss_enable</code>.
	 */
	public final TableField<ServerRecord, Boolean> SS_ENABLE = createField("ss_enable", org.jooq.impl.SQLDataType.BOOLEAN.defaulted(true), this, "");

	/**
	 * The column <code>public.server.public_address</code>.
	 */
	public final TableField<ServerRecord, InetAddress> PUBLIC_ADDRESS = createField("public_address", org.jooq.impl.DefaultDataType.getDefaultDataType("inet"), this, "", new InetAddressBinding());

	/**
	 * The column <code>public.server.call_route_config</code>.
	 */
	public final TableField<ServerRecord, CallRouteConfig> CALL_ROUTE_CONFIG = createField("call_route_config", org.jooq.impl.SQLDataType.OTHER, this, "", new CallRouteConfigBinding());

	/**
	 * The column <code>public.server.sms_route_config</code>.
	 */
	public final TableField<ServerRecord, SmsRouteConfig> SMS_ROUTE_CONFIG = createField("sms_route_config", org.jooq.impl.SQLDataType.OTHER, this, "", new SmsRouteConfigBinding());

	/**
	 * Create a <code>public.server</code> table reference
	 */
	public Server() {
		this("server", null);
	}

	/**
	 * Create an aliased <code>public.server</code> table reference
	 */
	public Server(String alias) {
		this(alias, SERVER);
	}

	private Server(String alias, Table<ServerRecord> aliased) {
		this(alias, aliased, null);
	}

	private Server(String alias, Table<ServerRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<ServerRecord, Long> getIdentity() {
		return Keys.IDENTITY_SERVER;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<ServerRecord> getPrimaryKey() {
		return Keys.SERVER_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<ServerRecord>> getKeys() {
		return Arrays.<UniqueKey<ServerRecord>>asList(Keys.SERVER_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Server as(String alias) {
		return new Server(alias, this);
	}

	/**
	 * Rename this table
	 */
	public Server rename(String name) {
		return new Server(name, null);
	}
}
